-module(n4u_relay).

-export([connect/2, send/2, recv/1, disconnect/1]).
% todo check where/how used


% N4U TCP relay endpoint handler

connect(IP, PortNo) ->
  {ok, Socket} = gen_tcp:connect(IP, PortNo, [{active, false}, {packet, 2}]),
  erlang:spawn(
    fun() ->
      recv(Socket)
    end),
  Socket.


send(Socket, Message) ->
  BinMsg = erlang:term_to_binary(Message),
  gen_tcp:send(Socket, BinMsg).


recv(Socket) ->
  {ok, A} = gen_tcp:recv(Socket, 0),
  wf:info(?MODULE, "Received: ~p~n", [A]),
  recv(Socket).


disconnect(Socket) ->
  gen_tcp:close(Socket).

